/*
 * Copyright 2016 - 2024 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <turbine/context.hpp>

#include "context.hpp"

namespace turbine {

void ContextDeleter::operator()(Context *p) noexcept {
	ox::safeDelete(p);
}

keel::Context const&keelCtx(Context const&ctx) noexcept {
	return ctx.keelCtx;
}

keel::Context &keelCtx(Context &ctx) noexcept {
	return ctx.keelCtx;
}

void setApplicationDataRaw(Context &ctx, void *applicationData) noexcept {
	if (applicationData) {
		ctx.applicationData.emplace();
		memcpy(&ctx.applicationData.value(), applicationData, sizeof(Wrap<void>));
	} else {
		ctx.applicationData.reset();
	}
}

WrapBase *applicationDataRaw(Context &ctx) noexcept {
	if (!ctx.applicationData) {
		return nullptr;
	}
	return std::bit_cast<WrapBase*>(&*ctx.applicationData);
}

}
